- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ zpush_name }}"
      namespace: "{{ namespace }}"
    policy_name: "{{ zpush_name }}-to-{{ ldap_name | default('ldap') }}"
    policy_namespace: "{{ ldap_namespace | default(namespace) }}"
    policy_state: "{{ 'present' if (do_ldap
                                    and do_network_policy)
                                else 'absent' }}"
    subject: "{{ ldap_name | default('ldap') }}"
    to:
    - number: "1389"
    - number: "1636"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ zpush_name }}"
      namespace: "{{ namespace }}"
    policy_name: "{{ zpush_name }}-to-{{ cyrus_name | default('cyrus') }}"
    policy_namespace: "{{ cyrus_namespace | default(namespace) }}"
    policy_state: "{{ 'present' if (do_network_policy)
                                else 'absent' }}"
    subject: "{{ cyrus_name | default('cyrus') }}"
    to:
    - number: 143
    - number: 993
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ zpush_name }}"
      namespace: "{{ namespace }}"
    policy_name: "{{ zpush_name }}-to-{{ postfix_name | default('postfix') }}"
    policy_namespace: "{{ postfix_namespace | default(namespace) }}"
    policy_state: "{{ 'present' if (do_network_policy
                                    and smtp_address | default(False))
                                else 'absent' }}"
    subject: "{{ postfix_name | default('postfix') }}"
    to:
    - number: "25"
    - number: "465"
- include_role:
    name: commons
    tasks_from: helpers/volume.yaml
  vars:
    vol_access_mode: "{{ 'ReadWriteOnce' if (rwx_storage is not defined)
                                         else 'ReadWriteMany' }}"
    vol_name: "{{ zpush_name }}"
    vol_size: "{{ zpush_data_capacity }}"
  when:
  - zpush_db_type == 'file'
- include_role:
    name: commons
    tasks_from: helpers/deployment.yaml
  vars:
    cpu_limit: "{{ zpush_cpu_limit }}"
    cpu_request: "{{ zpush_cpu_request }}"
    dc_data: "{{ lookup('template', 'zpush.j2') }}"
    dc_name: "{{ zpush_name }}"
    dc_replicas: "{{ 1 if (((zp_dc.resources | default([])) | length == 0)
                           or (zpush_db_type == 'file'
                               and (has_pvc.resources | default([])) | length > 0
                               and has_pvc.resources[0].spec.accessModes[0] == 'ReadWriteMany'))
                       else zpush_replicas }}"
    dc_tag: "{{ zpush_tag }}"
    exporter_idx: 1
    exporter_tag: "{{ httpexporter_tag }}"
    memory_limit: "{{ zpush_memory_limit }}"
    memory_request: "{{ zpush_memory_request }}"
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    ports:
    - 8080
    svc_name: "{{ zpush_name }}"
- include_role:
    name: commons
    tasks_from: helpers/route.yaml
  vars:
    route_host: "{{ zpush_fqdn }}"
    route_name: "{{ zpush_name }}"
    svc_name: "{{ zpush_name }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ default_namespace_match }}"
    policy_name: "public-to-{{ zpush_name }}"
    policy_state: "{{ 'present' if (do_network_policy)
                                else 'absent' }}"
    subject: "{{ zpush_name }}"
    to:
    - number: "8080"
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    is_exporter: True
    ports:
    - 9113
    svc_name: "{{ zpush_name }}"
    svc_state: "{{ 'present' if (do_exporters)
                             else 'absent' }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ prometheus_namespace_match }}"
    policy_name: "prometheus-to-{{ zpush_name }}"
    policy_state: "{{ 'present' if (do_exporters
                                    and do_network_policy)
                                else 'absent' }}"
    subject: "{{ zpush_name }}"
    to:
    - number: "9113"
- include_role:
    name: commons
    tasks_from: helpers/wait-for.yaml
  vars:
    check_with: "{{ lookup('k8s', api_version=deployment_apivers,
                           kind=deployment_kind, namespace=namespace,
                           resource_name=zpush_name) | default('') }}"
    obj_name: "{{ zpush_name }}"
    retries_for: 120
    wait_for: 10
  when:
  - dc_started is defined
  - dc_started is changed
- include_role:
    name: commons
    tasks_from: helpers/autoscale.yaml
  vars:
    autoscale_cpu_target: "{{ zpush_hpa_cpu_target | default(hpa_cpu_target | default(75)) }}"
    autoscale_name: "{{ zpush_name }}"
    autoscale_state: "{{ 'present' if (zpush_replicas not in [ 0, '0' ]
                                       and zpush_db_type != 'file'
                                       and do_memcached)
                                   else 'absent' }}"
    max_replicas: "{{ zpush_max_replicas | default(hpa_max_replicas | default(4)) }}"
    min_replicas: "{{ zpush_min_replicas | default(zpush_replicas) }}"
